diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 5bbd895c..2c22886c 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -1444,25 +2002,57 @@ object SquadService {
 
   /**
     * Utilized when one player attempts to join an existing squad in a specific role.
-    * @param player na
-    * @param squad_guid na
-    * @param position na
+    * Accessed by the joining player from the squad detail window.
+    * @param player the player who requested the role
+    * @param squad_guid the squad with the role
+    * @param position the index of the role
     */
-  final case class BidForPosition(player : Player, squad_guid : PlanetSideGUID, position : Int)
+  final case class BidForRole(player : Player, squad_guid : PlanetSideGUID, position : Int)
     extends Invitation(player.CharId, player.Name)
 
   /**
     * Utilized when one squad member issues an invite for some other player.
-    * @param char_id na
-    * @param name na
-    * @param squad_guid na
+    * Accessed by an existing squad member using the "Invite" menu option on another player.
+    * @param char_id the unique character identifier of the player who sent the invite
+    * @param name the name the player who sent the invite
+    * @param squad_guid the squad
     */
   final case class VacancyInvite(char_id : Long, name : String, squad_guid : PlanetSideGUID)
     extends Invitation(char_id, name)
 
-  final case class IndirectVacancy(player : Player, squad_guid : PlanetSideGUID)
+  /**
+    * Utilized to redirect an (accepted) invitation request to the proper squad leader.
+    * No direct action causes this message.
+    * @param player the player who would be joining the squad;
+    *               may or may not have actually requested it in the first place
+    * @param squad_guid the squad
+    */
+  final case class IndirectInvite(player : Player, squad_guid : PlanetSideGUID)
     extends Invitation(player.CharId, player.Name)
 
+  /**
+    * Utilized in conjunction with an external queuing data structure
+    * to search for and submit requests to other players
+    * for the purposes of fill out unoccupied squad roles.
+    * @param char_id the unique character identifier of the squad leader
+    * @param name the name of the squad leader
+    * @param squad_guid the squad
+    */
+  final case class ProximityInvite(char_id : Long, name : String, squad_guid : PlanetSideGUID)
+    extends Invitation(char_id, name)
+
+  /**
+    * Utilized in conjunction with an external queuing data structure
+    * to search for and submit requests to other players
+    * for the purposes of fill out an unoccupied squad role.
+    * @param char_id the unique character identifier of the squad leader
+    * @param name the name of the squad leader
+    * @param squad_guid the squad with the role
+    * @param position the index of the role
+    */
+  final case class InviteForRole(char_id : Long, name : String, squad_guid : PlanetSideGUID, position : Int)
+    extends Invitation(char_id, name)
+
   /**
     * Utilized when one player issues an invite for some other player for a squad that does not yet exist.
     * @param player na
@@ -1470,6 +2060,104 @@ object SquadService {
   final case class SpontaneousInvite(player : Player)
     extends Invitation(player.CharId, player.Name)
 
+  class SquadFeatures(val Squad : Squad) {
+    /**
+      * `initialAssociation` per squad is similar to "Does this squad want to recruit members?"
+      * The squad does not have to be flagged.
+      * Dispatches an `AssociateWithSquad` `SDAM` to the squad leader and ???
+      * and then a `SDDUM` that includes at least the squad owner name and char id.
+      * Dispatched only once when a squad is first listed
+      * or when the squad leader searches for recruits by proximity or for certain roles or by invite
+      * or when a spontaneous squad forms,
+      * whichever happens first.
+      * Additionally, the packets are also sent when the check is made when the continent is changed (or set).
+      */
+    private var initialAssociation : Boolean = true
+    /**
+      * na
+      */
+    private var switchboard : ActorRef = ActorRef.noSender
+    /**
+      * Waypoint data.
+      * The first four slots are used for squad waypoints.
+      * The fifth slot is used for the squad leader experience waypoint.
+      * @see `Start`
+      */
+    private var waypoints : Array[WaypointData] = Array[WaypointData]()
+    /**
+      * The particular position being recruited right at the moment.
+      * When `None`. no highlighted searches have been indicated.
+      * When a positive integer or 0, indicates distributed `InviteForRole` messages as recorded by `proxyInvites`.
+      * Only one position may bne actively recruited at a time in this case.
+      * When -1, indicates distributed `ProximityIvite` messages as recorded by `proxyInvites`.
+      * Previous efforts may or may not be forgotten if there is a switch between the two modes.
+      */
+    private var searchForRole : Option[Int] = None
+    /**
+      * Handle persistent data related to `ProximityInvite` and `InviteForRole` messages
+      */
+    private var proxyInvites : List[Long] = Nil
+    /**
+      * These useres rejected invitation to this squad.
+      * For the purposes of wide-searches for membership
+      * such as Looking For Squad checks and proximity invitation,
+      * the unique character identifier numbers in this list are skipped.
+      * Direct invitation requests from the non sqad member should remain functional.
+      */
+    private var refusedPlayers : List[Long] = Nil
+
+    def Start(implicit context : ActorContext) : SquadFeatures = {
+      switchboard = context.actorOf(Props[SquadSwitchboard], s"squad${Squad.GUID.guid}")
+      waypoints = Array.fill[WaypointData](5)(new WaypointData())
+      this
+    }
+
+    def Stop : SquadFeatures = {
+      switchboard ! akka.actor.PoisonPill
+      switchboard = Actor.noSender
+      waypoints = Array.empty
+      this
+    }
+
+    def InitialAssociation : Boolean = initialAssociation
+
+    def InitialAssociation_=(assoc : Boolean) : Boolean = {
+      initialAssociation = assoc
+      InitialAssociation
+    }
+
+    def Switchboard : ActorRef = switchboard
+
+    def Waypoints : Array[WaypointData] = waypoints
+
+    def SearchForRole : Option[Int] = searchForRole
+
+    def SearchForRole_=(role : Int) : Option[Int] = SearchForRole_=(Some(role))
+
+    def SearchForRole_=(role : Option[Int]) : Option[Int] = {
+      searchForRole = role
+      SearchForRole
+    }
+
+    def ProxyInvites : List[Long] = proxyInvites
+
+    def ProxyInvites_=(list : List[Long]) : List[Long] = {
+      proxyInvites = list
+      ProxyInvites
+    }
+
+    def Refuse : List[Long] = refusedPlayers
+
+    def Refuse_=(charId : Long) : List[Long] = {
+      Refuse_=(List(charId))
+    }
+
+    def Refuse_=(list : List[Long]) : List[Long] = {
+      refusedPlayers = list ++ refusedPlayers
+      Refuse
+    }
+  }
+
   object SquadList {
     def Publish(squad : Squad) : SquadInfo = {
       SquadInfo(
diff --git a/common/src/main/scala/services/teamwork/SquadServiceMessage.scala b/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
index 1e6c5559..c1826303 100644
--- a/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
+++ b/common/src/main/scala/services/teamwork/SquadServiceMessage.scala
@@ -2,8 +2,9 @@
 package services.teamwork
 
 import net.psforever.objects.Player
+import net.psforever.objects.zones.Zone
 
-final case class SquadServiceMessage(tplayer : Player, actionMessage : Any)
+final case class SquadServiceMessage(tplayer : Player, zone : Zone, actionMessage : Any)
 
 object SquadServiceMessage {
   final case class RecoverSquadMembership()
diff --git a/common/src/test/scala/game/SquadMembershipResponseTest.scala b/common/src/test/scala/game/SquadMembershipResponseTest.scala
index c640df04..e2727aee 100644
--- a/common/src/test/scala/game/SquadMembershipResponseTest.scala
+++ b/common/src/test/scala/game/SquadMembershipResponseTest.scala
@@ -3,7 +3,7 @@ package game
 
 import net.psforever.packet._
 import net.psforever.packet.game._
-import net.psforever.types.SquadRequestType
+import net.psforever.types.SquadResponseType
 import org.specs2.mutable._
 import scodec.bits._
 
@@ -30,7 +30,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (0-1)" in {
       PacketCoding.DecodePacket(string_01).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Invite
+          unk1 mustEqual SquadResponseType.Invite
           unk2 mustEqual 0
           unk3 mustEqual 0
           unk4 mustEqual 42771010L
@@ -46,7 +46,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (0-2)" in {
       PacketCoding.DecodePacket(string_02).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Invite
+          unk1 mustEqual SquadResponseType.Invite
           unk2 mustEqual 0
           unk3 mustEqual 0
           unk4 mustEqual 1176612L
@@ -62,7 +62,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (1-1)" in {
       PacketCoding.DecodePacket(string_11).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Unk01
+          unk1 mustEqual SquadResponseType.Unk01
           unk2 mustEqual 19
           unk3 mustEqual 0
           unk4 mustEqual 41530025L
@@ -78,7 +78,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (1-2)" in {
       PacketCoding.DecodePacket(string_12).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Unk01
+          unk1 mustEqual SquadResponseType.Unk01
           unk2 mustEqual 18
           unk3 mustEqual 0
           unk4 mustEqual 41578085L
@@ -94,7 +94,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (2-1)" in {
       PacketCoding.DecodePacket(string_21).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Accept
+          unk1 mustEqual SquadResponseType.Accept
           unk2 mustEqual 0
           unk3 mustEqual 0
           unk4 mustEqual 1300870L
@@ -110,7 +110,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (2-2)" in {
       PacketCoding.DecodePacket(string_22).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Accept
+          unk1 mustEqual SquadResponseType.Accept
           unk2 mustEqual 0
           unk3 mustEqual 0
           unk4 mustEqual 1300870L
@@ -126,7 +126,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (3-1)" in {
       PacketCoding.DecodePacket(string_31).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Reject
+          unk1 mustEqual SquadResponseType.Reject
           unk2 mustEqual 0
           unk3 mustEqual 3
           unk4 mustEqual 31035057L
@@ -142,7 +142,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (3-2)" in {
       PacketCoding.DecodePacket(string_32).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Reject
+          unk1 mustEqual SquadResponseType.Reject
           unk2 mustEqual 0
           unk3 mustEqual 2
           unk4 mustEqual 31106913L
@@ -158,7 +158,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (4-1)" in {
       PacketCoding.DecodePacket(string_41).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Cancel
+          unk1 mustEqual SquadResponseType.Cancel
           unk2 mustEqual 0
           unk3 mustEqual 2
           unk4 mustEqual 41578085L
@@ -174,7 +174,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (4-2)" in {
       PacketCoding.DecodePacket(string_42).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Cancel
+          unk1 mustEqual SquadResponseType.Cancel
           unk2 mustEqual 0
           unk3 mustEqual 2
           unk4 mustEqual 41607396L
@@ -190,7 +190,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (5-1)" in {
       PacketCoding.DecodePacket(string_51).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Leave
+          unk1 mustEqual SquadResponseType.Leave
           unk2 mustEqual 0
           unk3 mustEqual 1
           unk4 mustEqual 1176612L
@@ -206,7 +206,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (7-1)" in {
       PacketCoding.DecodePacket(string_71).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Disband
+          unk1 mustEqual SquadResponseType.Disband
           unk2 mustEqual 2
           unk3 mustEqual 0
           unk4 mustEqual 1176612L
@@ -222,7 +222,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (7-2)" in {
       PacketCoding.DecodePacket(string_72).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.Disband
+          unk1 mustEqual SquadResponseType.Disband
           unk2 mustEqual 0
           unk3 mustEqual 0
           unk4 mustEqual 41578085L
@@ -238,7 +238,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (8-1)" in {
       PacketCoding.DecodePacket(string_81).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.PlatoonInvite
+          unk1 mustEqual SquadResponseType.PlatoonInvite
           unk2 mustEqual 0
           unk3 mustEqual 0
           unk4 mustEqual 30910985L
@@ -254,7 +254,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (9-1)" in {
       PacketCoding.DecodePacket(string_91).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.PlatoonAccept
+          unk1 mustEqual SquadResponseType.PlatoonAccept
           unk2 mustEqual 0
           unk3 mustEqual 0
           unk4 mustEqual 297025L
@@ -270,7 +270,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (9-2)" in {
       PacketCoding.DecodePacket(string_92).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.PlatoonAccept
+          unk1 mustEqual SquadResponseType.PlatoonAccept
           unk2 mustEqual 0
           unk3 mustEqual 0
           unk4 mustEqual 30910985L
@@ -286,7 +286,7 @@ class SquadMembershipResponseTest extends Specification {
     "decode (b-1)" in {
       PacketCoding.DecodePacket(string_b1).require match {
         case SquadMembershipResponse(unk1, unk2, unk3, unk4, unk5, unk6, unk7, unk8) =>
-          unk1 mustEqual SquadRequestType.PlatoonCancel
+          unk1 mustEqual SquadResponseType.PlatoonCancel
           unk2 mustEqual 0
           unk3 mustEqual 1
           unk4 mustEqual 30910985L
@@ -300,119 +300,119 @@ class SquadMembershipResponseTest extends Specification {
     }
 
     "encode (0-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Invite, 0, 0, 42771010L, Some(1300870L), "HofD", false, None)
+      val msg = SquadMembershipResponse(SquadResponseType.Invite, 0, 0, 42771010L, Some(1300870L), "HofD", false, None)
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_01
     }
 
     "encode (0-2)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Invite, 0, 0, 1176612L, Some(1004937L), "SPOILERS", true, None)
+      val msg = SquadMembershipResponse(SquadResponseType.Invite, 0, 0, 1176612L, Some(1004937L), "SPOILERS", true, None)
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_02
     }
 
     "encode (1-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Unk01, 19, 0, 41530025L, Some(0L), "", true, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Unk01, 19, 0, 41530025L, Some(0L), "", true, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_11
     }
 
     "encode (1-2)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Unk01, 18, 0, 41578085L, Some(0L), "", true, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Unk01, 18, 0, 41578085L, Some(0L), "", true, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_12
     }
 
     "encode (2-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Accept, 0, 0, 1300870L, Some(42771010L), "VirusGiver", true, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Accept, 0, 0, 1300870L, Some(42771010L), "VirusGiver", true, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_21
     }
 
     "encode (2-2)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Accept, 0, 0, 1300870L, Some(30736877L), "VirusGiver", true, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Accept, 0, 0, 1300870L, Some(30736877L), "VirusGiver", true, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_22
     }
 
     "encode (3-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Reject, 0, 3, 31035057L, Some(42771010L), "HMFIC", false, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Reject, 0, 3, 31035057L, Some(42771010L), "HMFIC", false, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_31
     }
 
     "encode (3-2)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Reject, 0, 2, 31106913L, Some(42771010L), "DAN1111", false, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Reject, 0, 2, 31106913L, Some(42771010L), "DAN1111", false, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_32
     }
 
     "encode (4-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Cancel, 0, 2, 41578085L, Some(41607133L), "SAraisVanu", false, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Cancel, 0, 2, 41578085L, Some(41607133L), "SAraisVanu", false, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_41
     }
 
     "encode (4-2)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Cancel, 0, 2, 41607396L, Some(41324011L), "AirInjector", false, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Cancel, 0, 2, 41607396L, Some(41324011L), "AirInjector", false, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_42
     }
 
     "encode (5-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Leave, 0, 1, 1176612L, Some(1176612L), "CCRIDER", true, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Leave, 0, 1, 1176612L, Some(1176612L), "CCRIDER", true, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_51
     }
 
     "encode (7-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Disband, 2, 0, 1176612L, Some(0L), "", true, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Disband, 2, 0, 1176612L, Some(0L), "", true, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_71
     }
 
     "encode (7-2)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.Disband, 0, 0, 41578085L, Some(30910985L), "Wizkid45", true, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.Disband, 0, 0, 41578085L, Some(30910985L), "Wizkid45", true, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_72
     }
 
     "encode (8-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.PlatoonInvite, 0, 0, 30910985L, Some(41578085L), "Wizkid45", false, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.PlatoonInvite, 0, 0, 30910985L, Some(41578085L), "Wizkid45", false, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_81
     }
 
     "encode (9-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.PlatoonAccept, 0, 0, 297025L, Some(41605002L), "", true, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.PlatoonAccept, 0, 0, 297025L, Some(41605002L), "", true, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_91
     }
 
     "encode (9-2)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.PlatoonAccept, 0, 0, 30910985L, Some(41578085L), "Wizkid45", false, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.PlatoonAccept, 0, 0, 30910985L, Some(41578085L), "Wizkid45", false, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_92
     }
 
     "encode (b-1)" in {
-      val msg = SquadMembershipResponse(SquadRequestType.PlatoonCancel, 0, 1, 30910985L, Some(41578085L), "SAraisVanu", false, Some(None))
+      val msg = SquadMembershipResponse(SquadResponseType.PlatoonCancel, 0, 1, 30910985L, Some(41578085L), "SAraisVanu", false, Some(None))
       val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
       pkt mustEqual string_b1
diff --git a/pslogin/src/main/scala/WorldSessionActor.scala b/pslogin/src/main/scala/WorldSessionActor.scala
index 3fe21933..cacf4a97 100644
--- a/pslogin/src/main/scala/WorldSessionActor.scala
+++ b/pslogin/src/main/scala/WorldSessionActor.scala
@@ -155,6 +155,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
     galaxyService ! Service.Leave()
     LivePlayerList.Remove(sessionId)
     if(player != null && player.HasGUID) {
+      squadService ! Service.Leave(Some(player.CharId.toString))
       val player_guid = player.GUID
       //handle orphaned deployables
       DisownDeployables()
@@ -3561,7 +3562,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
           case None => false
         }
         avatarService ! AvatarServiceMessage(continent.Id, AvatarAction.PlayerState(avatar_guid, msg, spectator, wepInHand))
-        //squadService ! SquadServiceMessage(tplayer, SquadAction.Update(tplayer.CharId, tplayer.Health, tplayer.MaxHealth, tplayer.Armor, tplayer.MaxArmor, pos, zone.Number))
+        //squadService ! SquadServiceMessage(tplayer, continent, SquadAction.Update(tplayer.CharId, tplayer.Health, tplayer.MaxHealth, tplayer.Armor, tplayer.MaxArmor, pos, zone.Number))
       }
 
     case msg @ ChildObjectStateMessage(object_guid, pitch, yaw) =>
@@ -5019,15 +5020,15 @@ class WorldSessionActor extends Actor with MDCContextAware {
 
     case msg @ SquadDefinitionActionMessage(u1, u2, action) =>
       log.info(s"SquadDefinitionAction: $msg")
-        squadService ! SquadServiceMessage(player, SquadServiceAction.Definition(continent, u1, u2, action))
+        squadService ! SquadServiceMessage(player, continent, SquadServiceAction.Definition(u1, u2, action))
 
     case msg @ SquadMembershipRequest(request_type, unk2, unk3, player_name, unk5) =>
       log.info(s"$msg")
-      squadService ! SquadServiceMessage(player, SquadServiceAction.Membership(request_type, unk2, unk3, player_name, unk5))
+      squadService ! SquadServiceMessage(player, continent, SquadServiceAction.Membership(request_type, unk2, unk3, player_name, unk5))
 
     case msg @ SquadWaypointRequest(request, _, wtype, unk, info) =>
       log.info(s"Waypoint Request: $msg")
-      squadService ! SquadServiceMessage(player, SquadServiceAction.Waypoint(request, wtype, unk, info))
+      squadService ! SquadServiceMessage(player, continent, SquadServiceAction.Waypoint(request, wtype, unk, info))
 
     case msg @ GenericCollisionMsg(u1, p, t, php, thp, pv, tv, ppos, tpos, u2, u3, u4) =>
       log.info("Ouch! " + msg)

